<script lang="ts" setup>
import type { BaseCard } from '@/types/base';
import { ChevronLgRight } from 'slippers-ui/icons';
import { computed } from 'vue';

const props = defineProps<BaseCard>();

const hasLink = computed(() => {
  return Boolean(props.button?.config?.href);
});
</script>
<template>
  <component
    :is="hasLink ? 'a' : 'div'"
    class="card"
    v-bind="
      hasLink
        ? {
            'data-ga-name': button.config?.dataGaName || title,
            'data-ga-location': button.config?.dataGaLocation || 'body',
          }
        : {}
    "
  >
    <div>
      <SlpTypography variant="heading5-bold" tag="h3" class="slp-mt-8">{{ title }}</SlpTypography>
      <SlpTypography variant="body1" tag="p" class="slp-mt-24 slp-mb-24">{{ description }}</SlpTypography>
    </div>

    <div v-if="button" class="text-link">
      <SlpTypography variant="body1-bold" tag="p">{{ button.text }}</SlpTypography>
      <SlpIcon class="slp-ml-8" :icon="ChevronLgRight" alt="" />
    </div>
  </component>
</template>

<style lang="scss" scoped>
.card {
  background: $color-surface-50;
  border: 1px solid $color-surface-200;
  color: $color-primary-200;
  padding: $spacing-32;
  transition: all 0.3s ease-in-out;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  border-radius: 8px;
  &:where(a):hover {
    cursor: pointer;
    border-bottom-right-radius: 100px;
    .text-link {
      text-decoration: underline;
      -webkit-text-decoration: underline;
      .slp-icon {
        transform: translate(8px);
      }
    }
  }

  .text-link {
    transition: all 0.2s ease-in-out;
    display: inline-flex;
    align-items: center;
    text-align: center;
    vertical-align: middle;
    padding: 11px 0px;
    .slp-icon {
      margin-left: 4px;
      transition: transform 0.2s ease-in-out;
    }
  }
}
</style>
